Attribute VB_Name = "modDeclares"
Option Explicit

' //---------------------------------------------------------------------------
' // AUTHOR: gh0ul
' //
' // PROGRAM NAME:
' //   PI Demo  (Personality Implementation Demonstration)
' //
' // App REQUIREMENTS:
' //   This demo was coded on a WinNT 4.0 system clocked at 166Mhz.
' //   What does this mean to you??? If you use a slower processer then
' //   the sprites will move a lot slower... however, if you use one of todays
' //   mega fast puter's 300MHZ and above... the skeeters are really gonna HAUL ASS!!
' //   Solution?? adjust the speed of the sprites. With lower processers
' //   and resolutions you may have to eliminate a sprite or two.
' //
' // PURPOSE:
' //   This application was an experiment on using several sprites
' //   simultaneously, each one assuming a new personality when it is
' //   time for a change. This is done by using a personality table
' //   for each of the mosquitos. A personality table is nothing more
' //   than an array of integers. Each integer represents a given personality.
' //   In addition, a corresponding array, or table contains the amount
' //   of time the bug remains in each personality. YOu will have to
' //   browse through the code to really understand what I am talking
' //   about. When I say personality... I am refering to the current state of
' //   of the bug.
' //
' // PROBLEMS:
' //   The first thing you will notice when you execute this code is the
' //   flickering of the sprites when they overlap. As you will surely
' //   discover when you browse through my code, I use BitBlt, combined
' //   with a Background, and buffer. I use this technique to cover
' //   the tracers, and produce flicker free animation. Except I still get
' //   the flicker problem whenever the sprites come into contact with
' //   one another. Any help on a solution to this problem is greatly
' //   appreciated.
' //
' //
' //---------------------------------------------------------------------------
' // DATE:  December,05 99
' // TIME:  12:15am
' //---------------------------------------------------------------------------

' // Defined PicBox Objects for sprites and masks.
' // this simply makes it easier to access a picture box from a module
' // by allowing you to type less in the long run this dosen't seem to
' // slow the app down. However, I wouldn't add to many more because
' // to many would.

Public MsqMsk(0 To 5) As PictureBox
Public MsqMsk2(0 To 5) As PictureBox
Public MsqPic(0 To 5) As PictureBox
Public MsqPic2(0 To 5) As PictureBox

Public Frm As frmMain

Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

' // constants used by the BitBlt function
Public Const SRCCOPY = &HCC0020
Public Const SRCAND = &H8800C6
Public Const SRCPAINT = &HEE0086
Public Const SRCINVERT = &H660046


' // the number of targets on the screen at once.
Public iNum_Targets  As Integer
Public iSpeed        As Integer
Public iDirection    As Integer
Public iNewSkeeter   As Integer
Public iNumDead      As Integer
Public bDoingBugInfo As Boolean

' // varibles for firing
Public bFired        As Boolean
Public bShotOver     As Boolean
Public bHit          As Boolean
Public Shot_x        As Long
Public Shot_y        As Long

' // mosquito states... or personalities
Public Const MOS_RIGHT    As Integer = 1
Public Const ZIGZAG_RIGHT As Integer = 2

Public Const MOS_LEFT     As Integer = 3
Public Const ZIGZAG_LEFT  As Integer = 4

Public Const HOVERING     As Integer = 5
Public Const ATTACKING    As Integer = 6
Public Const EVADING      As Integer = 7
Public Const DROPPING     As Integer = 8

Public Const DEAD         As Integer = 666


' // maximum allowed mosquitos on the screen at once.
Public Const MAX_MOS      As Integer = 8

' // type stores info for one mosquito...
' // Individual Mosquito Characteristics
Public Type Indiv_Mosq_Chars
 x                     As Long    ' // The X coor of a mosquito
 y                     As Long    ' // The Y coor of a mosquito
 Speed                 As Integer ' // the speed of a mosquito
 State                 As Integer ' // this mosquitos current personality
 PerPtrn(1 To MAX_MOS) As Integer ' // An array to hold this mosquitos prersonality pattern
 Time(1 To MAX_MOS)    As Integer ' // the amount of time spent in each state
 TimeCntr              As Integer ' // counts down the time
 ArrayPos              As Integer ' // the current position in the StPtrn Array
End Type

' // now make an array of the above type to access individual bugs
' // a possibly better way to to this is to make a Mosquito Class
' // file, that way each individual bug can be treatead as an object with
' // it's own "untouchable" data. this works much the same way.

Public Cur_Mos(1 To MAX_MOS) As Indiv_Mosq_Chars

' // position of the cursor
Public mse_x%, mse_y%

' // Game Counter
Public GameCntr&

' // True if game is paused
Public bPaused As Boolean

