Attribute VB_Name = "modGame"
Option Explicit

Global MsqMsk(0 To 5) As PictureBox
Global MsqMsk2(0 To 5) As PictureBox
Global MsqPic(0 To 5) As PictureBox
Global MsqPic2(0 To 5) As PictureBox
Global Frm As Form


Sub Main()
   ' Refrence all the Pictureboxes and the form so that they
   ' can be accessed with less work
   
   ' mos that face left
   Set MsqPic(0) = frmMain.ms_pic(0)
   Set MsqPic(1) = frmMain.ms_pic(1)
   Set MsqPic(2) = frmMain.ms_pic(2)
   Set MsqPic(3) = frmMain.ms_pic(3)
   Set MsqPic(4) = frmMain.ms_pic(4)
   Set MsqPic(5) = frmMain.ms_pic(5)
   
   Set MsqMsk2(0) = frmMain.ms_msk(0)
   Set MsqMsk2(1) = frmMain.ms_msk(1)
   Set MsqMsk2(2) = frmMain.ms_msk(2)
   Set MsqMsk2(3) = frmMain.ms_msk(3)
   Set MsqMsk2(4) = frmMain.ms_msk(4)
   Set MsqMsk2(5) = frmMain.ms_msk(5)
   
   ' mos that face right
   Set MsqPic2(0) = frmMain.ms_pic2(0)
   Set MsqPic2(1) = frmMain.ms_pic2(1)
   Set MsqPic2(2) = frmMain.ms_pic2(2)
   Set MsqPic2(3) = frmMain.ms_pic2(3)
   Set MsqPic2(4) = frmMain.ms_pic2(4)
   Set MsqPic2(5) = frmMain.ms_pic2(5)
   
   Set MsqMsk(0) = frmMain.ms_msk2(0)
   Set MsqMsk(1) = frmMain.ms_msk2(1)
   Set MsqMsk(2) = frmMain.ms_msk2(2)
   Set MsqMsk(3) = frmMain.ms_msk2(3)
   Set MsqMsk(4) = frmMain.ms_msk2(4)
   Set MsqMsk(5) = frmMain.ms_msk2(5)
   
   
   Set Frm = frmMain
   
   Load frmMain
   frmMain.Show
End Sub

Sub InitMos()
   Dim i As Integer
   
   Randomize Timer
   ' initialize mosquitos
   For i = 1 To iNum_Targets
      With Cur_Mos(i)
         'pick a state for each mosquito; initially
         .State = Int((ZIGZAG_LEFT * Rnd) + MOS_RIGHT)
         ' what side of the screen will this mos start?
         If .State < MOS_LEFT And .State >= MOS_RIGHT Then
            'starting left to right
            .X = -100
            .Y = Int(((frmMain.ScaleHeight - 40) * Rnd) + 1)
         ElseIf .State > ZIGZAG_RIGHT And .State <= ZIGZAG_LEFT Then
            ' starting right to left
            .X = frmMain.ScaleWidth + 50
            .Y = Int(((frmMain.ScaleHeight - 40) * Rnd) + 1)
         End If
         
      End With
      Rnd
   Next i
   
   
End Sub


Sub ActivateMos()
   '
   Dim i As Integer
   ' how many mosquitos working with??
   For i = 1 To iNum_Targets
   
     Select Case Cur_Mos(i).State
        
        Case MOS_RIGHT
           '
           iDirection = MOS_RIGHT
           Cur_Mos(i).X = Cur_Mos(i).X + iSpeed
        Case ZIGZAG_RIGHT
           '
           iDirection = MOS_RIGHT
           Cur_Mos(i).Y = Cur_Mos(i).Y - 3
           Cur_Mos(i).X = Cur_Mos(i).X + iSpeed
        Case MOS_LEFT
           '
           Cur_Mos(i).X = Cur_Mos(i).X - iSpeed
           iDirection = MOS_LEFT
        Case ZIGZAG_LEFT
           '
           iDirection = MOS_LEFT
           Cur_Mos(i).Y = Cur_Mos(i).Y + 3
           Cur_Mos(i).X = Cur_Mos(i).X - iSpeed
           
        Case HOVERING
           '
           iDirection = iDirection
           Cur_Mos(i).X = Cur_Mos(i).X
           
        Case ATTACKING
           ' nothing yet
           iDirection = iDirection
           ' make the mosquitos flock to the cursor
           'Cur_Mos(i).X = mse_x
          'Cur_Mos(i).Y = mse_y
        Case DROPPING
           iDirection = iDirection
           ' stop at current position
           Cur_Mos(i).X = Cur_Mos(i).X
           ' drop straight down
           Cur_Mos(i).Y = Cur_Mos(i).Y + iSpeed
           
     End Select
     
     DoMosActions i
   Next i
End Sub


Sub DoMosActions(CurMos As Integer)
    
    Dim u As Long
    Dim i As Integer
    ' an array of 6 different frame variables
    ' each one for each different mosquito
    Static frame(1 To MAX_MOS) As Integer
    
        
    ' keep the skeeters flying  6 because doing frames in multiples of 2
    If frame(CurMos) >= 6 Then frame(CurMos) = 0
    
    ' if the mosquito is dropping... use only fame 3
    If Cur_Mos(CurMos).State = DROPPING Then frame(CurMos) = 3
    
    ' has it gone off the screen??
    If iDirection = MOS_RIGHT Then
      If Cur_Mos(CurMos).X > Frm.ScaleWidth Then
         Cur_Mos(CurMos).X = -45
         ' pick a random spot for re-entry to the screen.
         Cur_Mos(CurMos).Y = Int(((frmMain.ScaleHeight - 40) * Rnd) + 1)
      End If
    ElseIf iDirection = MOS_LEFT Then
      If Cur_Mos(CurMos).X < -45 Then
         Cur_Mos(CurMos).X = Frm.ScaleWidth + 45
         ' pick a random spot for re-entry to the screen.
         Cur_Mos(CurMos).Y = Int(((frmMain.ScaleHeight - 40) * Rnd) + 1)
      End If
    End If
    ' has the dropping mosquito gone off the screen?
    If Cur_Mos(CurMos).Y > frmMain.ScaleHeight Then
         Cur_Mos(CurMos).X = Int(((frmMain.ScaleWidth - 40) * Rnd) + 1)
         Cur_Mos(CurMos).Y = -35
    End If
    
    
'// BitBlt calls
    ' clear the buffer, but only the parts where the mosquito was previously.
    ' does not matter which picture you use to size this up because thy are
    ' all the same size.
    u = BitBlt(Frm.picBuf.hDC, Cur_Mos(CurMos).X, Cur_Mos(CurMos).Y, MsqMsk2(frame(CurMos)).ScaleWidth, MsqMsk2(frame(CurMos)).ScaleHeight, Frm.picBG.hDC, 0, 0, SRCCOPY)
    ' do animaton while move the skeeter.
    If iDirection = MOS_RIGHT Then     ' right to left
      ' mask
      u = BitBlt(Frm.picBuf.hDC, Cur_Mos(CurMos).X, Cur_Mos(CurMos).Y, MsqMsk2(frame(CurMos)).ScaleWidth, MsqMsk2(frame(CurMos)).ScaleHeight, MsqMsk2(frame(CurMos)).hDC, 0, 0, SRCAND)
      ' Image
      u = BitBlt(Frm.picBuf.hDC, Cur_Mos(CurMos).X, Cur_Mos(CurMos).Y, MsqPic2(frame(CurMos)).ScaleWidth, MsqPic2(frame(CurMos)).ScaleHeight, MsqPic2(frame(CurMos)).hDC, 0, 0, SRCINVERT)
    ElseIf iDirection = MOS_LEFT Then  ' left to right
      ' mask
      u = BitBlt(Frm.picBuf.hDC, Cur_Mos(CurMos).X, Cur_Mos(CurMos).Y, MsqMsk(frame(CurMos)).ScaleWidth, MsqMsk(frame(CurMos)).ScaleHeight, MsqMsk(frame(CurMos)).hDC, 0, 0, SRCAND)
      ' Image
      u = BitBlt(Frm.picBuf.hDC, Cur_Mos(CurMos).X, Cur_Mos(CurMos).Y, MsqPic(frame(CurMos)).ScaleWidth, MsqPic(frame(CurMos)).ScaleHeight, MsqPic(frame(CurMos)).hDC, 0, 0, SRCINVERT)
    End If
    
    ' copy the entire buffer onto the screen
    u = BitBlt(Frm.hDC, 0, 0, frmMain.picBuf.ScaleWidth, frmMain.picBuf.ScaleHeight, frmMain.picBuf.hDC, 0, 0, SRCCOPY)
'// End BItBlt Calls

    'If iNum_Targets <= 2 Then frame(CurMos) = frame(CurMos) + 1: Exit Sub
    ' advance frame...
    ' notice I skip a frame.... this makes the mosquitos wings appear to move faster
    ' this could have easily been accomplished by using only 3 frames rather than
    ' 5.
    frame(CurMos) = frame(CurMos) + 2
    
    
End Sub


Sub ChangeStates()
    Dim i As Integer
    
    Randomize Timer
    
    For i = 1 To iNum_Targets
      ' Pick a random state for this mosquito
      ' This is quite possibly the simplest form of AI...
      ' Could be further improved. Given a set of rules to follow, along
      ' with these states, a better form of fuzzy logic could be implemented.
      Cur_Mos(i).State = Int((DROPPING * Rnd) + MOS_RIGHT)
    Next i
End Sub
